<!-- <p>page-not-found works!</p> -->
<div class="mainContainer">
  <div class="leftContainer" *ngIf="project">
    <div class="generalInformation">
      <div class="projectIcon">
        <h1>
          <mat-icon class="icon">crop_square</mat-icon>
        </h1>
      </div>
      <div class="projectName">
        <h1 *ngIf="project && project.name">
          {{ project.name }}
        </h1>
      </div>
      <div class="buttonInHeader" *ngIf="project.projectStatus !== 'public'">
        <button
          mat-raised-button
          (click)="cloneProject()"
          id="duplicateProjectButton"
        >
          <mat-icon>copy_all</mat-icon>
          <span>{{ 'projectManagement.duplicateProj' | translate }}</span>
        </button>
      </div>
      <div class="buttonInHeader" *ngIf="project.projectStatus !== 'public'">
        <button
          mat-raised-button
          color="accent"
          (click)="publishToGit()"
          id="publishProjectButton"
          [disabled]="false"
        >
          <mat-icon>publish</mat-icon>
          <span>{{ 'projectManagement.publishProject' | translate }}</span>
        </button>
      </div>
      <div class="buttonInHeader" *ngIf="project.projectStatus !== 'public'">
        <button
          mat-raised-button
          color="warn"
          (click)="deleteProject()"
          id="deleteProjectButton"
          [disabled]="false"
        >
          <mat-icon>delete</mat-icon>
          <span>{{ 'projectManagement.delete' | translate }}</span>
        </button>
      </div>
    </div>
    <div class="projectInformation">
      <!-- <mat-expansion-panel expanded="true" *ngIf="project && project.description && project.description"> -->
      <mat-expansion-panel expanded="true" *ngIf="project">
        <mat-expansion-panel-header>
          {{ 'projectManagement.generalInformation' | translate }}
        </mat-expansion-panel-header>
        <form class="generalInformationForm">
          <div>
            <mat-form-field class="widthProjectName">
              <!-- (input)="onSave([projectDescription.value, projectName.value])" -->
              <input
                (change)="onInputsChange()"
                matInput
                placeholder="{{ 'adminprojects.projectname' | translate }}"
                name="projectName"
                [(ngModel)]="project.name"
                [disabled]="
                  !user?.isAdmin &&
                  ({project, user, minimumRight: Right.WRITE} | userhasRightForProject)
              
                "
                #projectName
              />
            </mat-form-field>
          </div>
          <mat-error *ngIf="projectName.value === ''" class="errors">
            <mat-icon>{{ 'warning' }}</mat-icon>
            <p>{{ 'error.projectPage.projectNameRequired' | translate }}</p>
          </mat-error>
          <div>
            <mat-form-field class="widthProjectDescr">
              <textarea
                (change)="onInputsChange()"
                matInput
                [matTextareaAutosize]="true"
                placeholder="{{ 'form.label.project.description' | translate }}"
                style="min-width: 20px"
                name="projectDescription"
                [(ngModel)]="project.description"
                [disabled]="
                  !user?.isAdmin &&
                  ({project, user, minimumRight: Right.WRITE} | userhasRightForProject)
                "
                #projectDescription
              ></textarea>
            </mat-form-field>
          </div>
          <mat-error *ngIf="projectDescription.value === ''" class="errors">
            <mat-icon>{{ 'warning' }}</mat-icon>
            <p>
              {{ 'error.projectPage.projectDescriptionRequired' | translate }}
            </p>
          </mat-error>
        </form>
        <p *ngIf="project && project.isPublic && project.published_web_app">
          Link to public data:
          <a href="https://git.rwth-aachen.de/">https://git.rwth-aachen.de/</a>
        </p>
      </mat-expansion-panel>
    </div>
    <div
      *ngIf="
        (user?.isAdmin ||
          ({project, user, minimumRight: Right.MANAGE} | userhasRightForProject) && 
          (project.projectStatus === 'hidden' || project.projectStatus === 'on_review'))
      "
      class="userManagementCard"
    >
      <mat-expansion-panel expanded="true">
        <mat-expansion-panel-header>
          {{ 'menu.userManagement' | translate }}
        </mat-expansion-panel-header>
        <div>
          <button
            mat-raised-button
            color="primary"
            [disabled]="
              !user?.isAdmin &&
              ({project, user, minimumRight: Right.MANAGE} | userhasRightForProject)
            "
            class="addUserBtn"
            (click)="addUser()"
          >
            {{ 'projectManagement.addUser' | translate }}
          </button>
          <button
            mat-raised-button
            color="primary"
            [disabled]="
              !user?.isAdmin &&
              ({project, user, minimumRight: Right.MANAGE} | userhasRightForProject)
            "
            (click)="inviteUserMail()"
          >
            {{ 'projectManagement.inviteUser' | translate }}
          </button>
        </div>
        <table mat-table [dataSource]="contributors" matSort>
          <ng-container matColumnDef="firstName">
            <th mat-header-cell *matHeaderCellDef mat-sort-header>
              {{ 'projectManagement.firstName' | translate }}
            </th>
            <td mat-cell *matCellDef="let element" class="userTableFirstName">
              {{ element.user.firstName }}
            </td>
          </ng-container>
          <ng-container matColumnDef="lastName">
            <th mat-header-cell *matHeaderCellDef mat-sort-header>
              {{ 'projectManagement.lastName' | translate }}
            </th>
            <td mat-cell *matCellDef="let element">
              {{ element.user.lastName }}
            </td>
          </ng-container>
          <ng-container matColumnDef="permission">
            <th mat-header-cell *matHeaderCellDef>
              {{ 'projectManagement.permission' | translate }}
            </th>
            <td mat-cell *matCellDef="let element">
              <div class="userPermissionContainer">
                <button
                  mat-icon-button
                  matTooltip="Read"
                  [color]="element.rights.includes(Right.READ) ? 'primary' : ''"
                  [disabled]="
                    !user?.isAdmin &&
                    ({project, user, minimumRight: Right.MANAGE} | userhasRightForProject)"
                >
                  <!-- class="icon-size-xxs {{
                  element.permission.includes(Right.READ)
                    ? 'icon-primary'
                    : 'icon-disabled'
                }}" -->
                  <mat-icon>description</mat-icon>
                </button>
                <button
                  mat-icon-button
                  matTooltip="Write"
                  (click)="changePermission(element.id, Right.WRITE)"
                  [disabled]="
                    !user?.isAdmin &&
                    ({project, user, minimumRight: Right.MANAGE} | userhasRightForProject)

                  "
                >
                  <!-- class="icon-size-xxs  {{
                  element.permission.includes(Right.WRITE)
                    ? 'icon-primary'
                    : 'icon-disabled'
                }}" -->
                  <mat-icon>edit</mat-icon>
                </button>
                <button
                  mat-icon-button
                  matTooltip="Manage"
                  (click)="changePermission(element.id, Right.MANAGE)"
                  [disabled]="
                    !user?.isAdmin &&
                    ({project, user, minimumRight: Right.MANAGE} | userhasRightForProject)
                  "
                >
                  <!-- class="icon-size-xxs  {{
                  element.permission.includes(Right.MANAGE)
                    ? 'icon-primary'
                    : 'icon-disabled'
                }}" -->
                  <mat-icon>build</mat-icon>
                </button>
              </div>
            </td>
          </ng-container>
          <ng-container matColumnDef="action">
            <th mat-header-cell *matHeaderCellDef>
              {{ 'projectManagement.action' | translate }}
            </th>
            <td mat-cell *matCellDef="let element">
              <button
                (click)="deleteContributor(element)"
                mat-icon-button
                matTooltip="Remove User"
                aria-label="Example icon-button with a heart icon"
                [disabled]="
                  !user?.isAdmin &&
                  ({project, user, minimumRight: Right.MANAGE} | userhasRightForProject)
                "
              >
                <!-- class="icon-warn icon-size-xxs" -->
                <mat-icon>person_remove</mat-icon>
              </button>
            </td>
          </ng-container>
          <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
          <tr mat-row *matRowDef="let row; columns: displayedColumns"></tr>
        </table>
      </mat-expansion-panel>
    </div>
  </div>
  <div class="rightContainer" *ngIf="project">
    <energy-platform-project-map></energy-platform-project-map>
  </div>
  <div *ngIf="!project">
    <h1>Project not found</h1>
  </div>
</div>
